//*****************************************************************************************//
//**********************************VER 1.0 data:20190524**********************************//
//**********************************    author : fred    **********************************//
//********************************** IO wakeup  demo code   **********************************//
//********************************** reference the note  **********************************//
//*****************************************************************************************//

//#include <intrins.h>
#include <CMS/CMS8S5880.H>

//***********define constant*********//

#define		MAIN_CLOCK_FREQ		16000000uL		//unit:Hz
#define		TM0_OF_us			2000			//timer0 overflow times unit:us
#define		divider				4
#define		TM_value			(65535-(TM0_OF_us*(MAIN_CLOCK_FREQ/(4*1000000))))

#define		GPIO_INT_RISING 1
#define		GPIO_INT_FALLING 2
#define		GPIO_INT_RISING_FALLING 3

//*******************variable*********************//


//*******************initial*********************//



//*******************MAIN*********************//


void Delayus(uint32_t us)
{
	us *= 24;
	while(--us)
	{
		clrwdt()
	}
}

void main (void) 
{
		
		P0 = 0x00;
		P1 = 0x00;
		P2 = 0x00;
		P3 = 0x040;
		
		P0TRIS = 0xff;//output=1,input=0
		P1TRIS = 0xff;
		P2TRIS = 0xa3;
		P3TRIS = 0xff;
	
	P3 = 0x040;
	P3 = 0x040;
	Delayus(10000);	
		P2RD = 0x40;
		P2UP = 0x1c;
		
		P2EXTIF = 0;
		P2EXTIE = 0x00;	


	while(1)
  {
			
		clrwdt()
			
		P3 = 0x00;			//P36 watch
		Delayus(10000);	
			
		EA = 0;
		
		P0 = 0x00;
		P1 = 0x00;
		P2 = 0x00;
		P3 = 0x40;
		
		P0TRIS = 0xff;//output=1,input=0
		P1TRIS = 0xff;
		P2TRIS = 0xa3;
		P3TRIS = 0xff;
		
		P0OD = 0x00;
		P1OD = 0x00;
		P2OD = 0x00;
		P3OD = 0x00;
		
		P0RD = 0x00;
		P1RD = 0x00;
		P2RD = 0x40;
		P3RD = 0x00;
		
		P0UP = 0x00;
		P1UP = 0x00;
		P2UP = 0x1c;
		P3UP = 0x00;
		
		//P22 P23 P24 falling edge wakeup  P26 rising edge wakeup
		
		P22EICFG = GPIO_INT_FALLING;//P22
		P23EICFG = GPIO_INT_FALLING;//P23
		P24EICFG = GPIO_INT_FALLING;//P24
		P26EICFG = GPIO_INT_RISING;//P26
		
		P2EXTIF = 0;
		P2EXTIE = 0x5c;
		
		
		clrwdt()
		EA = 1;
		PCON = 0x06;//SWE=1,STOP=1
		_nop_();
		_nop_();
		_nop_();
						
	}
					
				
}

//-----------------------------------------------------------------------------------------------------------

void Port0Interrupt_ISR (void) interrupt P0EI_VECTOR
{	  
		P0EXTIF		= 0x00;

	
}

void Port1Interrupt_ISR (void) interrupt P1EI_VECTOR
{	  
		P1EXTIF		= 0x00;

	
}

void Port2Interrupt_ISR (void) interrupt P2EI_VECTOR
{
	
	P2EXTIF = 0;

	
	
}


void Port3Interrupt_ISR (void) interrupt P3EI_VECTOR
{	  
		P3EXTIF		= 0x00;

	
}


void INT0Interrupt_ISR (void) interrupt INT0_VECTOR
{	  
		IE0		= 0;

	
}


void INT1Interrupt_ISR (void) interrupt INT1_VECTOR
{	  
		IE1		= 0;

	
}
